BUILD_DIR := out
IMAGES_DIR := images

# pandoc is a handy tool for converting between numerous text formats:
# http://johnmacfarlane.net/pandoc/installing.html
PANDOC := pandoc

# pandoc options
# Liberation fonts: http://en.wikipedia.org/wiki/Liberation_fonts
EBOOK_OPTIONS := --toc --epub-stylesheet=epub.css --epub-cover-image=cover.jpg --base-header-level=1 --highlight-style=zenburn
INPUT_FORMAT :=--from markdown+mmd_title_block+table_captions+multiline_tables+grid_tables+implicit_figures+task_lists+lists_without_preceding_blankline+tex_math_dollars+yaml_metadata_block+rebase_relative_paths
#INPUT_FORMAT :=--from markdown+mmd_title_block+table_captions+multiline_tables+grid_tables+implicit_figures+lists_without_preceding_blankline+tex_math_dollars
LUA_FILTER :=--lua-filter=ref/diagram-generator.lua --metadata=plantumlPath:"ref/plantuml.jar" #--metadata=dotPath:"c:\Program Files (x86)\Graphviz2.38\bin\dot.exe"
HTML_OPTIONS :=--embed-resources --standalone --table-of-contents --css=ref/style.css --number-sections --mathjax --table-caption-position=below --figure-caption-position=below
DOCX_OPTIONS :=--embed-resources --standalone --reference-doc=ref/MDL_Tech-Med.docm --table-of-contents --table-caption-position=below --figure-caption-position=below
ODT_OPTIONS :=--embed-resources --standalone --reference-doc=ref/MDL_Tech-Med.odt --table-of-contents --table-caption-position=below --figure-caption-position=below
PDF_OPTIONS :=--embed-resources --standalone --toc --top-level-division=chapter --shift-heading-level-by=1 --number-sections --variable mainfont="Liberation Serif" --variable sansfont="Liberation Sans" --variable monofont="Liberation Mono" --variable fontsize=10pt --variable documentclass=book -V geometry:margin=2cm --table-caption-position=below --figure-caption-position=below
#PDF_OPTIONS :=--embed-resources --standalone --toc --top-level-division=chapter --base-header-level=1 --number-sections --variable mainfont="Liberation Serif" --variable sansfont="Liberation Sans" --variable monofont="Liberation Mono" --variable fontsize=10pt --variable documentclass=book -V geometry:margin=2cm

# download kindlegen from http://www.amazon.com/gp/feature.html?ie=UTF8&docId=1000765211
KINDLEGEN := kindlegen
KINDLEGEN_OPTS :=

MARKDOWN := $(wildcard *.md) $(wildcard */*.md)
PDF   := $(patsubst %.md, $(BUILD_DIR)/%.pdf       ,$(MARKDOWN))
EBOOK := $(patsubst %.md, $(BUILD_DIR)/%.epub      ,$(MARKDOWN))
DOCX  := $(patsubst %.md, $(BUILD_DIR)/%.docx      ,$(MARKDOWN))
ODT   := $(patsubst %.md, $(BUILD_DIR)/%.odt       ,$(MARKDOWN))
WIKI  := $(patsubst %.md, $(BUILD_DIR)/%.mediawiki ,$(MARKDOWN))
HTML  := $(patsubst %.md, $(BUILD_DIR)/%.html      ,$(MARKDOWN))
PLANTUML := $(wildcard *.plantuml)
PNG  := $(patsubst %.plantuml, images/%.png        ,$(PLANTUML))

.PHONY: all checkdirs pdf ebook doc odt wiki html clean png

#all: checkdirs  $(HTML) $(PDF) $(EBOOK) $(DOCX) $(WIKI)
all: checkdirs png $(HTML) $(DOCX) $(ODT) $(PDF)

checkdirs: $(BUILD_DIR) $(IMAGES_DIR)

pdf: checkdirs png $(PDF)

ebook: checkdirs png $(EBOOK)

doc: checkdirs png $(DOCX)

odt: checkdirs png $(ODT)

wiki: checkdirs png $(WIKI)

html: checkdirs png $(HTML)

png:  checkdirs $(PNG)

$(BUILD_DIR):
	@mkdir -p $@

$(IMAGES_DIR):
	@mkdir -p $@
	
# generate PlantUML diagramms
$(IMAGES_DIR)/%.png: %.plantuml
	java -Djava.awt.headless=true -jar ref/plantuml.jar -charset UTF-8  -o $(IMAGES_DIR) $<
	
# generate PDF
$(BUILD_DIR)/%.pdf: %.md
	mkdir -p $$(dirname $@)
	$(PANDOC) $(INPUT_FORMAT)  $< -t latex -o $@ $(LUA_FILTER)  $(PDF_OPTIONS)

# generate both iBooks (.epub) and then Kindle (.mobi) formats
$(BUILD_DIR)/%.epub: %.md
	mkdir -p $$(dirname $@)
	$(PANDOC) $(EBOOK_OPTIONS) --from=markdown_github --self-contained -o $@ $<
	$(KINDLEGEN) $(KINDLEGEN_OPTS) $@ > /dev/null

# generate Microsoft Word documents (.docx)
$(BUILD_DIR)/%.docx: %.md
	mkdir -p $$(dirname $@)
	$(PANDOC) $(INPUT_FORMAT)  $< -t docx -o $@ $(LUA_FILTER)  $(DOCX_OPTIONS)

# generate LibreOffice documents (.odt)
$(BUILD_DIR)/%.odt: %.md
	mkdir -p $$(dirname $@)
	$(PANDOC) $(INPUT_FORMAT)  $< -t odt -o $@ $(LUA_FILTER%)  $(ODT_OPTIONS)

# generate files suitable for pasting into mediawiki
$(BUILD_DIR)/%.mediawiki: %.md
	mkdir -p $$(dirname $@)
	$(PANDOC) -t mediawiki --from=markdown_github --highlight-style=zenburn --self-contained -o $@ $<

# generate HTML files
$(BUILD_DIR)/%.html: %.md
	mkdir -p $$(dirname $@)
	$(PANDOC) $(INPUT_FORMAT)  $< -t html5 -o $@ $(LUA_FILTER)  $(HTML_OPTIONS)

clean:
	@rm -rf $(BUILD_DIR)
	@rm -rf $(IMAGES_DIR)
